QueuesInfoData.prototype.MEMBER_ACTIVE_ID = 'id';
QueuesInfoData.prototype.MEMBER_ACTIVE_NAME = 'active';
QueuesInfoData.prototype.MEMBER_NAME_NAME = 'queuename';
QueuesInfoData.prototype.MEMBER_OBJECTID_NAME = 'objectid';
QueuesInfoData.prototype.ALL_QUEUES_INFO_MEMBERS_NAMES = [QueuesInfoData.prototype.MEMBER_ACTIVE_ID, QueuesInfoData.prototype.MEMBER_ACTIVE_NAME
                                                          , QueuesInfoData.prototype.MEMBER_NAME_NAME, QueuesInfoData.prototype.MEMBER_OBJECTID_NAME];

function QueuesInfoData()
{	
	var data = null;
	var maxId = 0;
	
  this.setData = function(queuesInfoDataArrayP)
  {
	  maxId = 0;
	  this.data = queuesInfoDataArrayP;
	  for(var i = 0; i < this.data.length; i++)
	  {
	    if(this.data[i].id > maxId)
	    {
	      maxId = this.data[i].id;
	    }
	  }
  }
	
  var queuesInfoDataArray = [];
    /*[
        {"id": 1, "active":false, "queuename":"testowa 1", "objectid":"e46d11eb02ba29c66fb82a45dba8ed65"},
        {"id": 2, "active":true, "queuename":"testowa 2", "objectid":"g46d11eb02ba29c66fb82a45dba8ed65"},
        {"id": 3, "active":false, "queuename":"testowa 4", "objectid":"i46d11eb02ba29c66fb82a45dba8ed65"},
        {"id": 4, "active":false, "queuename":"testowa 3", "objectid":"h46d11eb02ba29c66fb82a45dba8ed65"}
      ];*/
  this.setData(queuesInfoDataArray);
  
  //------------EVENTS-------------------
  var dataChangedHandlers = new Array();
  this.DataChanged = function(fn)
  {
	  dataChangedHandlers.push(fn);
  }
  
  function onDataChanged(sender, eventArgs)
  {
	if(dataChangedHandlers.length > 0)
	{
		for(var i = 0; i < dataChangedHandlers.length; i++)
		{
			if(dataChangedHandlers[i] != null)
			{
				dataChangedHandlers[i](sender, eventArgs);
			}
		}
	}
  }
  //------------EVENTS-------------------
  
  this.getAsArray = function()
  {
    return this.data;
  }
  
  this.getAt = function(index)
  {
    return this.data[index];
  }
  
  this.getDataItemPkAt = function(index)
  {
    return this.getAt(index).id;
  }
  
  this.getIndex = function(queueInfoItem)
  {
    for(var i = 0; i < this.getLength(); i++)
    {
      if(this.isPrimaryKeyEqaul(queueInfoItem, this.getAt(i)))
      {
        return i;
      }
    }
    return -1;
  }
  
  this.isPrimaryKeyEqaul = function(firstQueueInfoItem, secondQueueInfoItem)
  {
    //return (firstQueueInfoItem.id == secondQueueInfoItem.id);
	  return this.isPrimaryKeyEqaulToValue(firstQueueInfoItem, secondQueueInfoItem.id);
  }
  
  this.isPrimaryKeyEqaulToValue = function(queueInfoItem, pkValue)
  {
    return (queueInfoItem.id == pkValue);
  }
  
  this.getLength = function()
  {
    return this.data.length;
  }
  
  this.updateItem = function(item)
  {
	  var itemIn = this.getQueueInfoById(item.id);
	  itemIn.active = item.active;
	  itemIn.queuename = item.queuename;
	  itemIn.objectid = item.objectid;
	  if(itemIn.active == true)
    {
    	this.setActiveQueue(item.id, true);
    }
	  onDataChanged(this, new DataChangedEventArgs(DataChangedEventArgs.prototype.OPERATION_TYPE_MODIFIED
	    		, QueuesInfoData.prototype.ALL_QUEUES_INFO_MEMBERS_NAMES
	    		, itemIn));
  }
  
  this.addItem = function(active, name, objectId)
  {
	var index = this.data.length;
	var id = getNextId();
    this.data[index] = {"id":id, "active":active, "queuename":name, "objectid":objectId};
    if(active == true)
    {
    	this.setActiveQueue(id, true);
    }
    onDataChanged(this, new DataChangedEventArgs(DataChangedEventArgs.prototype.OPERATION_TYPE_ADDED
    		, QueuesInfoData.prototype.ALL_QUEUES_INFO_MEMBERS_NAMES
    		, this.data[index]));
    return this.data[index];
  }
  
  this.getItemByPk = function(pkValue)
  {
	  for(var i = 0; i < this.data.length; i++)
	  {
		  if(this.isPrimaryKeyEqaulToValue(this.data[i], pkValue) == true)
		  {
			  return this.data[i];
		  }
	  }
	  return null;
  }
  
  this.removeByPk = function(pkValue)
  {
	  var arrayBefore = this.data;
	  var arrayNew = new Array();
	  for(var i = 0; i < arrayBefore.length; i++)
	  {
		  if(this.isPrimaryKeyEqaulToValue(arrayBefore[i], pkValue) == false)
		  {
			  arrayNew[arrayNew.length] = arrayBefore[i];
		  }
	  }
	  this.setData(arrayNew);
	  onDataChanged(this, new DataChangedEventArgs(DataChangedEventArgs.prototype.OPERATION_TYPE_REMOVED
	    		, []
	    		, null));
	  return null;
  }
  
  function getNextId()
  {
    maxId = maxId + 1;
    return maxId;
  }
  
  this.getQueueInfoByObjectId = function(objectId)
  {
    for(var i = 0; i < this.getLength(); i++)
    {
      if(this.getAt(i).objectid == objectId)
      {
        return this.getAt(i);
      }
    }
    return null;
  }
  
  this.getActiveQueueInfo = function()
  {
    for(var i = 0; i < this.getLength(); i++)
    {
      if(this.getAt(i).active == true)
      {
        return this.getAt(i);
      }
    }
    return null;
  }
  
  this.getActiveQueueInfoObjectid = function()
  {
    if(this.getActiveQueueInfo() != null)
    {
      return this.getActiveQueueInfo().objectid;
    }
    return null;
  }
  
  this.getActiveQueueInfoQueueName = function()
  {
    if(this.getActiveQueueInfo() != null)
    {
      return this.getActiveQueueInfo().queuename;
    }
    return null;
  }
  
  this.getQueueInfoById = function(id)
  {
    for(var i = 0; i < this.getLength(); i++)
    {
      if(this.getAt(i).id == id)
      {
        return this.getAt(i);
      }
    }
    return null;
  }
  
  this.getId = function(row)
  {
    return this.getAt(row).id;
  }
  
  this.getActive = function(row)
  {
    return this.getAt(row).active;
  }
  
  this.getQueueName = function(row)
  {
    return this.getAt(row).queuename;
  }
  
  this.getObjectId = function(row)
  {
    return this.getAt(row).objectid;
  }
  
  this.setActiveQueue = function(id, active)
  {
    if(active == true)//tylko jak rzeczywiscie ktoras wartosc sie zmienia
    {
      for(var i = 0; i < this.getLength(); i++)
      {
        if(this.getAt(i).active == active && !this.isPrimaryKeyEqaul(this.getAt(i), this.getQueueInfoById(id)))//wszystkie inne wartosci
        {
          this.getAt(i).active = false;
          onDataChanged(this, new DataChangedEventArgs(DataChangedEventArgs.prototype.OPERATION_TYPE_MODIFIED
        		  , [QueuesInfoData.prototype.MEMBER_ACTIVE_NAME]
        		  , this.getAt(i)));
        }
      }
      if(this.getQueueInfoById(id).active != active)
      {
        this.getQueueInfoById(id).active = active;
        onDataChanged(this, new DataChangedEventArgs(DataChangedEventArgs.prototype.OPERATION_TYPE_MODIFIED
        		, [QueuesInfoData.prototype.MEMBER_ACTIVE_NAME]
        		, this.getQueueInfoById(id)));
      }
    }
  }
  
  this.setQueueName = function(objectId, queuename)
  {
    this.getQueueInfoByObjectId(objectId).queuename = queuename;
    onDataChanged(this, new DataChangedEventArgs(DataChangedEventArgs.prototype.OPERATION_TYPE_MODIFIED
    		, [QueuesInfoData.prototype.MEMBER_NAME_NAME]
    		, this.getQueueInfoByObjectId(objectId)));
  }
  
  this.setActive = function(row, active)
  {
    this.setActiveQueue(this.getAt(row).id, active);
    //zdarzenie jest wywolywane w setActiveQueue(..)
    //onDataChanged(this, new DataChangedEventArgs(DataChangedEventArgs.prototype.OPERATION_TYPE_MODIFIED, this.getAt(row)));
  }

  this.checkAndSetConsistantData = function()
  {
    if(this.getActiveQueueInfo() == null)
    {
    	if(this.getLength() > 0)
    	{
    		this.getAt(0).active = true;
    		onDataChanged(this, new DataChangedEventArgs(DataChangedEventArgs.prototype.OPERATION_TYPE_MODIFIED
    	    		, [QueuesInfoData.prototype.MEMBER_ACTIVE_NAME]
    	    		, this.getAt(0)));
    	}
    }
  }
  
  this.setQueueName = function(row, queuename)
  {
    this.getAt(row).queuename = queuename;
    onDataChanged(this, new DataChangedEventArgs(DataChangedEventArgs.prototype.OPERATION_TYPE_MODIFIED
    		, [QueuesInfoData.prototype.MEMBER_NAME_NAME]
    		, this.getAt(row)));
  }
  
  this.setObjectId = function(row, objectid)
  {
    var dataRow = this.getAt(row);
    dataRow.objectid = objectid;
    onDataChanged(this, new DataChangedEventArgs(DataChangedEventArgs.prototype.OPERATION_TYPE_MODIFIED
    		, [QueuesInfoData.prototype.MEMBER_OBJECTID_NAME]
    		, dataRow));
  }
  
  this.toString = function()
  {
	  var s = '[';
	  for(var i = 0; i < this.getLength(); i++)
	  {
		  s = s + '<' + this.getId(i) + ',' + this.getActive(i) + ',' + this.getQueueName(i) + ',' + this.getObjectId(i) + '>';
	  }
	  s = s + ']';
	  return s;
  }
  
  this.toJsonString = function()
  {
	  return JSON.stringify(this.getAsArray());
  }
  
  this.loadDataFromJsonString = function(s)
  {
    if(s != null && s != '')
    {
  	  var dataFromJson = JSON.parse(s);
  	  this.setData(dataFromJson);
  	}
  }
  
}
