//----STRING PROTOTYPE------------------------------------------------------------------------------------------\\

function indexOfWithNr(lookFor, nr)
{
  var sIn = this;
  var index= -1;
  var resIndex= -1;
  for (var i = 0; i < nr; i++)
  {
    index = sIn.indexOf(lookFor);
    if(index < 0)
    {
      return index;
    }
    resIndex = resIndex + index + lookFor.length;
    sIn = sIn.substring(index + lookFor.length, sIn.length);
  }
  return resIndex;
}

function trimStr()
{
	return this.replace(/^\s+|\s+$/g, '');
}

String.prototype.indexOfNr = indexOfWithNr
String.prototype.trim = trimStr

//----FIREFOX PREFERENCES---------------------------------------------------------------------------------------\\

var prefManager = null;

function getPrefs()
{
  if(prefManager == null)
  {
    prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
  }
  return prefManager;
}

function getPrefType(key)
{
	//alert('getPrefType + start');
	return getPrefs().getPrefType(key); 
}

function hasPrefValue(key)
{
	try
	{
		if(isDebug())
		{
			logDebug('hasPrefValue, [key,' + key + ']');
		}

		//TODO: nie wiedzialem jak to inaczej sprawdzic
		var pretfType = getPrefType(key);
		if(isDebug())
		{
			logDebug('result: ' + pretfType);
		}
		if(pretfType == getPrefs().PREF_BOOL)
		{
			if(isDebug())
			{
				logDebug('[common.js->hasPrefValue], PREF_BOOL');
			}
			return true;
		}
		else if(pretfType == getPrefs().PREF_STRING)
		{
			if(isDebug())
			{
				logDebug('[common.js->hasPrefValue], PREF_STRING');
			}
			return true;
		}
		else if(pretfType == getPrefs().PREF_INT)
		{
			if(isDebug())
			{
				logDebug('[common.js->hasPrefValue], PREF_INT');
			}
			return true;
		}
		else if(pretfType == getPrefs().PREF_INVALID)
		{
			if(isDebug())
			{
				logDebug('[common.js->hasPrefValue], PREF_INVALID');
			}
		}
		else
		{
			logError('[common.js->hasPrefValue], UNKNOWN TYPE: [' + pretfType + ']');
		}
		return false;
	}
	catch(err)
	{
		logError('[common.js->hasPrefValue], ERROR: ' + err);
	}
	return false;
}

function getStringPref(key)
{
  return getPref('string', key);
}

function getIntPref(key)
{
  return getPref('int', key);
}

function getBoolPref(key)
{
  return getPref('bool', key);
}

function getPref(type, key)
{
  var prefs = getPrefs();
  if(hasPrefValue(key))
  {
    if(type == 'string')
    {
      return prefs.getCharPref(key);
    }
    else if(type == 'int')
    {
      return prefs.getIntPref(key);
    }
    else if(type == 'bool')
    {
      return prefs.getBoolPref(key);
    }
  }
  return '';
}

function setPref(type, key, value)
{
  var prefs = getPrefs();
  if(type == 'string')
  {
    prefs.setCharPref(key, value);
  }
  else if(type == 'int')
  {
    prefs.setIntPref(key, value);
  }
  else if(type == 'bool')
  {
    prefs.setBoolPref(key, value);
  }
}

function setBoolPref(key, value)
{
  setPref('bool', key, value)
}

//----                          ---------------------------------------------------------------------------------------\\

function getCurrentTimeString()
{
  return getTimeString(new Date());
}

function getTimeString(time)
{
  var hours = time.getHours();
  var minutes = time.getMinutes();
  var seconds = time.getSeconds();
  if (minutes < 10)
  {
    minutes = "0" + minutes;
  }
  if (seconds < 10)
  {
    seconds = "0" + seconds;
  }
  return hours + ':' + minutes + ':' + seconds;
}

//------ LOGGING ---------------------------------------------------------------------------------------------------------\\
function isDebug()
{
	return false; 
}

function logMsg(msg, level)
{
	var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
                                 .getService(Components.interfaces.nsIConsoleService);
	consoleService.logStringMessage(msg);
}

function logDebug(msg)
{
	//alert(msg);
	logMsg(msg, 'deb');
}

function logInfo(msg)
{
	logMsg(msg, 'inf');
}

function logError(msg)
{
	logMsg(msg, 'err');
}

function showError(msg)
{
	alert(msg);
}

function showInfo(msg)
{
  alert(msg);
}

//------------ BROWSER ---------------------------------------------------------------------------------//
function openNewTabFromDialog(url)
{
    var win = Components.classes['@mozilla.org/appshell/window-mediator;1']
                                 .getService(Components.interfaces.nsIWindowMediator)
                                 .getMostRecentWindow('navigator:browser');

   win.gBrowser.selectedTab = win.gBrowser.addTab(url);
}

//--------------- string bundles
function getStrBundle(bundleName)
{
  if(bundle == null)
  {
    bundle = document.getElementById(bundleName);
  }
  
  return bundle;
}

function getStr(key)
{
  return getBundle().getString(key);
}

