//depends on:
//common.js

var MAX_NR_OF_QUEUES_INFO = 7;

function getBundle()
{
	return getStrBundle("queuemonitor-bundle");
}

function getStr(key)
{
  return getBundle().getString(key);
}

function getStrF(key, params)
{
  return getBundle().getFormattedString(key, params);
}

function initPrefsWindow()         
{
  window.sizeToContent();
  initGeneralTab();
  initQueuesTab();
  getQueuesInfoData().DataChanged(queuesInfoDataChanged);
}

//--------------GENERAL TAB------
var queuesDropDownModel = null;
function initGeneralTab()
{
	//setObjectIdInput(getPrefObjectId());
	setCallMaxWaitTimeThreshold(getPrefWaitingCallThresholdAlert());
	setIntervalValueInWindow(getPrefHitInterval());
	//alert('configwindow.js - > isPrefTimerEnabledDefined(): ' + isPrefTimerEnabledDefined());
	if(isPrefTimerEnabledDefined() == false)//pierwsze uruchomienie, to ustawiamy na true
	{
		setTimerEnabledCheckbox(true);
	}
	else
	{
		setTimerEnabledCheckbox(getPrefTimerEnabled());
	}
	
	var queuesInfoDropDown = getQueuesInfoDropDownList();
	var queuesInfoModel = getQueuesInfoData().getAsArray();
	var queuesInfoColumnsModel = [
    function(data){
      return data.queuename;
    },
    function(data){
      return data.id;
    },
    function(data){
      return '(' + data.objectid + ')';
    },
    function(data){
      return data.active;
    }   
  ];
  var model = new QueuesConfigDropDownModel({
    "dropdownlist": queuesInfoDropDown,
    "model": queuesInfoModel,
    "columnModel": queuesInfoColumnsModel
  });
  
  model.update();
  queuesDropDownModel = model;	
}

function queuesInfoDropDownListSelChanged()
{
  var queuesInfoDropDownSelItem = getQueuesInfoDropDownListSelItem();
  if(queuesInfoDropDownSelItem != null)
  {
    getQueuesInfoData().setActiveQueue(queuesInfoDropDownSelItem.value, true);
  }
}

function getQueuesInfoDropDownListSelItem()
{
  var queuesInfoDropDown = getQueuesInfoDropDownList();
  if(queuesInfoDropDown != null && queuesInfoDropDown.selectedItem != null)//przy inizjowaniuokna lub jak wybierane jest inaczej niz przez uzytkownika, to jest null
  {
    return queuesInfoDropDown.selectedItem;
  }
}

function getQueuesInfoDropDownListValueFromWindow()
{
  var queuesInfoDropDownSelItem = getQueuesInfoDropDownListSelItem();
  if(queuesInfoDropDownSelItem != null)
  {
    return queuesInfoDropDownSelItem.value;
  }
  return null;
}

function getQueuesInfoDropDownList()
{
  return document.getElementById("queuesInfoDropDown");
}

function updateQueuesInfoDropDown()
{
  queuesDropDownModel.update(getQueuesInfoData().getAsArray());
}

function getCallMaxWaitTimeThreshold()
{
  return document.getElementById('callMaxWaitTimeThreshold');
}

function getIntervalControl()
{
  return document.getElementById('intervalInput');
}

function getObjectIdInput()
{
  throw 'Method obsolete';
  //return document.getElementById('objectIdInput');
}

function getTimerEnabledCheckbox()
{
  return document.getElementById('timerEnabledCheckbox');
}

function getIntervalValueFromWindow()
{
  return getIntervalControl().value;
}

function getObjectIdInputFromWindow()
{
  return getObjectIdInput().value;
}

function getCallMaxWaitTimeThresholdFromWindow()
{
  return getCallMaxWaitTimeThreshold().value;
}

function getTimerEnabledCheckboxFromWindow()
{
	return getTimerEnabledCheckbox().checked;
}

function setIntervalValueInWindow(v)
{
  getIntervalControl().value = v;
}

function setCallMaxWaitTimeThreshold(v)
{
	getCallMaxWaitTimeThreshold().value = v;
}

function setObjectIdInput(v)
{
  //throw 'Method obsolete';
	getObjectIdInput().value = v;
}

function setTimerEnabledCheckbox(checked)
{
	getTimerEnabledCheckbox().checked = checked;
}

//---------QUEUES TAB------------------
var queuesInfoData = null;

function getQueuesInfoData()
{  
  if(queuesInfoData == null)
  {
    queuesInfoData = new QueuesInfoData();
    try
    {
      queuesInfoData.loadDataFromJsonString(getConfigurationObject());
    }
    catch(err)
    {
    	logError('[configwindow.getQueuesInfoData]: <' + err + ', ' + err.description + '>');
    }
  }
  return queuesInfoData;
}

function getQueuesInfoTree()
{
  return document.getElementById("queuesInfoTree");
}

function initQueuesTab()
{
  var queuesInfoTree = getQueuesInfoTree();
  var queuesInfoData = getQueuesInfoData();

  treeView.setData(queuesInfoData);
  queuesInfoTree.view = treeView;
  
}

function queuesInfoDataChanged(sender, eventArgs)
{
	//alert('OPERATION_TYPE: ' + eventArgs.getOperationType() +', ' + eventArgs.getMemberName() + ', ' + sender.toString());
	updateQueuesInfoViewElements();
}

function addQueueInfo()
{
	var queuesInfoData = getQueuesInfoData();
	if(queuesInfoData.getLength() >= MAX_NR_OF_QUEUES_INFO)
	{
		showInfo(getStrF('configwindow.max.queueinfo.alert', [MAX_NR_OF_QUEUES_INFO]));
	    return;
	}
	else
	{
	    openDialog("chrome://queuemonitor/content/editqueueinfo.xul", "", "chrome, dialog, modal, centerscreen", queuesInfoData, null);
	    queuesInfoData.checkAndSetConsistantData();
	}
}

function editQueueInfo()
{
	var selectRowsPkValues = getSelectedRowsPkValues();
	if(selectRowsPkValues == null || selectRowsPkValues.length == 0)
	{
		alert(getStr("configwindow.select.queueinfo.alert"));
	}
	else
	{
		openDialog("chrome://queuemonitor/content/editqueueinfo.xul", "", "chrome, dialog, modal, centerscreen", getQueuesInfoData(), selectRowsPkValues);
	}
}

function removeQueueInfo()
{
  var selectRowsPkValues = getSelectedRowsPkValues();
  if(selectRowsPkValues == null || selectRowsPkValues.length == 0)
  {
	  alert(getStr("configwindow.select.queueinfo.alert"));
  }
  else
  {
	  treeView.removeByPk(selectRowsPkValues[0]);
	  getQueuesInfoData().checkAndSetConsistantData();
  }
}

function updateQueuesInfoTree()
{
  var queuesInfoTree = getQueuesInfoTree();
  treeView.setData(getQueuesInfoData());
  queuesInfoTree.view = treeView;
}

function updateQueuesInfoViewElements()
{
  updateQueuesInfoTree();
  updateQueuesInfoDropDown();
}

function queuesInfoItemSelected()
{
  var queuesInfoTree = getQueuesInfoTree();
}

function getSelectedRowsPkValues()
{
  var rangeCount = treeView.selection.getRangeCount();
  var rowsIdsList = new Array();;
  for(var i = 0; i < rangeCount; i++)
  {
     var start = {};
     var end = {};
     treeView.selection.getRangeAt(i, start, end);
     for(var c = start.value; c <= end.value; c++)
     {
        rowsIdsList.push(treeView.getDataItemPkAt(c));
     }
  }
  return rowsIdsList;
}

//------VALIDATION AND SAVE-------------
function validateConfigWindowData()
{
  //var intervalFromWindow = getIntervalValueFromWindow();
  //var res = validateRefreshInterval(intervalFromWindow);
  var objectIdFromWindow = getQueuesInfoDropDownListValueFromWindow();//getObjectIdInputFromWindow();
  var res = validateObjectId(objectIdFromWindow);
  if(res == null || res == '')
  {
	  var callMaxWaitTimeThresholdFromWindow = getCallMaxWaitTimeThresholdFromWindow();
	  res = validateCallMaxWaitTimeThreshold(callMaxWaitTimeThresholdFromWindow);
  }
  return res;
}

function savePrefsWindow()
{
  var validationResult = '';
  
	//var objectIdFromWindow = getQueuesInfoDropDownListValueFromWindow();
	//var intervalFromWindow = getIntervalValueFromWindow();
	//setPrefHitInterval(intervalFromWindow);
    
  var timerEnabledFromWindow = getTimerEnabledCheckboxFromWindow();
  setPrefTimerEnabled(timerEnabledFromWindow);
  //jesli true, to wymuszenie odswiezenia
  setPrefForceRefresh(timerEnabledFromWindow);
  
  var callMaxWaitTimeThreshold = getCallMaxWaitTimeThresholdFromWindow();
  validationResult = validateCallMaxWaitTimeThreshold(callMaxWaitTimeThreshold);
  if(validationResult != null && validationResult != '')
  {
    alert(validationResult);
  }
  else
  {
	setPrefWaitingCallThresholdAlert(callMaxWaitTimeThreshold);
  }
  
  var objectIdFromWindow = getQueuesInfoDropDownListValueFromWindow();
  validationResult = validateObjectId(objectIdFromWindow);
  if(validationResult != null && validationResult != '')
  {
    alert(validationResult);
  }
  setConfigurationObject(getQueuesInfoData().toJsonString());

  this.close();
}

function onTreeClicked(event)
{
	this.editQueueInfo();
}
