//depends on: common.js

var bundle = null;
var msTillLastRequest = 0;
var msRefreshInternalInterval = 4000;

function getBundle()
{
  if(bundle == null)
  {
    bundle = document.getElementById("queuemonitor-bundle");
  }
  
  return bundle;
}

function getStr(key)
{
  return getBundle().getString(key);
}

function getStrF(key, params)
{
  return getBundle().getFormattedString(key, params);
}

function makeRequestFake()
{
   var xmlobject = 'adasdasd|asdasdasd|2009-11-23 21:20:01|1|98 ';
   interpretResult(xmlobject);
}

function makeRequestHttp(url, parameters)
{
	if(isDebug())
	{
		logDebug('[queuemonitor.makeRequestHttp] - start');
	}
   advAJAX.get({url: url,
      mimeType: 'text/plain',
      timeout : 4000,
      onTimeout : onTimeout,
      onSuccess : onSuccess,
      onError : onError
    });
}

function onTimeout(obj)
{
  writeError(getStr('connection.timeout'));
  logError('[queuemonitor.makeRequestHttp], ' + getStr('connection.timeout'));
}

function onSuccess(obj)
{
	if(isDebug())
	{
		logDebug('[queuemonitor.onSuccess] - start, [obj.responseText, ' + obj.responseText + ']');
	}
	var resulttext = obj.responseText;
	try
  	{
    	interpretResult(resulttext);
    	writeError('');
  	}
  	catch(err)
  	{
    	writeError(err);
  	}
}

function onError(obj)
{
  writeError("Blad! Status: '" + obj.status + "'");
}

function interpretResult(result)
{                      
  var nrOfWaitingUsers = 0;
  var maxWaitTime = 0;
  try
  {
    if(result != '')
    {
      var separator = '|';
      var sep3Index = result.indexOfNr(separator, 3);
      var sep4Index = result.indexOfNr(separator, 4);
      if(sep3Index >= 0 && sep4Index >= 0)
      {
        nrOfWaitingUsers = result.substring(sep3Index + separator.length, sep4Index);
        maxWaitTime = result.substring(sep4Index + separator.length, result.length);
      }
      else
      {
        nrOfWaitingUsers = 0;
        maxWaitTime = 0;
        var errorMsgIndex = result.indexOfNr(getStr('result.object.not.found.token'), 1);
        if(errorMsgIndex >= 0)
        {
            throw getStr('result.object.not.found.error');
        }
        throw getStr('result.format.not.recognized');
      }
    }
  }
  finally
  {
    setRefreshInfo(nrOfWaitingUsers, maxWaitTime)
  }
}

function setRefreshInfo(nrOfWaitingUsers, maxWaitTime)
{
  if(maxWaitTime > getPrefWaitingCallThresholdAlert())
  {
    setTimerEnabledStateView('waiting_call_alert');
  }
  else
  {
    setTimerEnabledStateView('working');
  }

  writeToStatusNrOfWaitingUsers(nrOfWaitingUsers);
  writeToStatusCallMaxWaitTime(maxWaitTime);
}

function makeRequest(objectId)
{
  makeRequestHttp("https://ipfon24.ipfon.pl/main.php?action=pokaz_widok_ivrq&pobierz=1&obiekt=" + objectId, '');
  //makeRequestFake();
}

function setTimerEnabledByMenuItem(menuitem)
{
  if(getPrefTimerEnabled() == true)
  {
    setPrefTimerEnabled(false);
    setTimerEnabledStateView('not_working');
    menuitem.setAttribute("checked", "false");
  }
  else
  {
    var canMakeRequestResult = validateIfCanMakeRequest();
    if(canMakeRequestResult == '')
    {
      setPrefTimerEnabled(true);
      setTimerEnabledStateView('working');
      menuitem.setAttribute("checked", "true");
      runOnce(true);
    }
    else
    {
      alert(canMakeRequestResult);
    }
  }
}

function startVoipRefesh()
{
   var timerEanbled = getPrefTimerEnabled();
   if(timerEanbled == false)
   {
    setTimerEnabledStateView('not_working');
   }
   else
   {
    setTimerEnabledStateView('working');
   }
   runOnce(true);
   startVoipRefeshIn();
}

function getQueuesInfoConfigurationData()
{//TODO: zrobic odpowiednie cache'owanie obeiktu z uwaga na mozliwosc zmiany konfiguracji
  var queuesInfoData = new QueuesInfoData();
  try
  {
    queuesInfoData.loadDataFromJsonString(getConfigurationObject());
  }
  catch(err)
  {
	  logError('[queuemonitor.getQueuesInfoConfigurationData]: <' + err + ', ' + err.description + '>');
	  showError(err + ', ' + err.description);
  }
  return queuesInfoData;
}

function runOnce(force)
{
	 try
	  {
		 if(isDebug())
		 {
			 logDebug('[queuemonitor.runOnce] - start, [force, ' + force + ']');
		 }
	     var timerEanbled = getPrefTimerEnabled();
	     
	     if(timerEanbled == false)
	     {
	      setTimerEnabledStateView('not_working');
	     }

	     if(timerEanbled == true)
	     {
	       var intervalInMs = getPrefHitInterval() * 1000;
	  
	       if(intervalInMs <= msTillLastRequest || force == true)
	       {
	         var canMakeRequestResult = validateIfCanMakeRequest();
	         if(canMakeRequestResult != null && canMakeRequestResult != '')
	         {
	          writeError(canMakeRequestResult);
	         }
	         else
	         {
	          msTillLastRequest = 0;
	          makeRequest(getQueuesInfoConfigurationData().getActiveQueueInfoObjectid());
	         }
	       }
	     }
	     msTillLastRequest = msTillLastRequest + msRefreshInternalInterval;
	     if(isDebug())
		 {
			 logDebug('[queuemonitor.runOnce] - finish');
		 }
	  }
	  catch(err)
	  {
	    var errorMsg = "Blad! " + err;
	    if(err.description != null)
	    {
	      errorMsg += err.description;
	    }
	    logError(errorMsg);
	    writeError(errorMsg);
	  }
}

function startVoipRefeshIn()
{
  var doForce = false;
  if(getPrefForceRefresh() == true)
  {
    setPrefForceRefresh(false);
    doForce = true;
  }
  runOnce(doForce);
  setTimeout('startVoipRefeshIn()', msRefreshInternalInterval);
}

function validateIfCanMakeRequest()
{
  var objectid = getQueuesInfoConfigurationData().getActiveQueueInfoObjectid();
  return validateObjectId(objectid);
}

function setTimerEnabledStateView(status)
{//'working', 'not_working', 'waiting_call_alert'
  var menuitem = document.getElementById('TimerEnabled');
  menuitem.setAttribute("checked","true");
  if(status == 'working')
  {
	var queuename = getQueuesInfoConfigurationData().getActiveQueueInfoQueueName();
    setStatusIconTooltipText(getStrF('refresh.enabled', [queuename]));
  }
  else if(status == 'not_working')
  {
    setStatusIconTooltipText(getStr('refresh.disabled'));
    clearStatusBarFields();
    menuitem.setAttribute("checked","false");
  }
  else if(status == 'waiting_call_alert')
  {
    setStatusIconTooltipText(getStr('waitingcall.longtime'));
  }
  setStatusIcon(status);
}

function setStatusIconTooltipText(text)
{
  var statusIcoPanelId = 'rightPanel4';
  if(document.getElementById(statusIcoPanelId) != null)
  {
    document.getElementById(statusIcoPanelId).tooltipText = text;
  }
}

function setStatusIcon(state)
{
  var statusIcoPanelId = 'rightPanel4';
  if(document.getElementById(statusIcoPanelId) != null)
  {
    if(state == 'working')
    {
      document.getElementById(statusIcoPanelId).image = 'chrome://queuemonitor/skin/connected.ico';
    }
    else if(state == 'not_working')
    {
      document.getElementById(statusIcoPanelId).image = 'chrome://queuemonitor/skin/disconnected.ico';
    }
    else if(state == 'waiting_call_alert')
    {
      document.getElementById(statusIcoPanelId).image = 'chrome://queuemonitor/skin/waitingcallalert.ico';
    }
    else
    {
      //
    }
  }
}

//-----HELPERS

function writeToStatusBarErrorPanel(msg)
{
  writeToStatusBar('errorPanel', msg);
}

function writeToStatusBarRightPanel1(msg)
{
  writeToStatusBar('rightPanel1', msg);
}

function writeToStatusBarRightPanel2(msg)
{
  writeToStatusBar('rightPanel2', msg);
}

function getStatusBarPanel2()
{
  return document.getElementById('rightPanel2');
}

function getStatusBarErrorPanel()
{
  return document.getElementById('errorPanel');
}

function writeToStatusBar(id, msg)
{
  document.getElementById(id).label = msg;
}

function writeToStatusNrOfWaitingUsers(nrOfWaitingUsers)
{
  writeToStatusBarRightPanel1(nrOfWaitingUsers);
}

function writeToStatusCallMaxWaitTime(maxWaitTime)
{
  writeToStatusBarRightPanel2(maxWaitTime + ' ' + getStr('seconds.label'));
}

function writeError(error)
{
  writeToStatusBarErrorPanel(error);
  logError(error);
}

function clearStatusBarFields()
{
  writeStatusBarFields(0,0, '');
}

function writeStatusBarFields(nrOfWaitingUsers, callMaxWaitTime, error)
{
  writeToStatusNrOfWaitingUsers(nrOfWaitingUsers);
  writeToStatusCallMaxWaitTime(callMaxWaitTime);
  writeToStatusBarErrorPanel(error);
}


